Index: /trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 305)
@@ -181,9 +181,41 @@
 !       2. Opacity calculation
             if (aerofixed.or.(i_h2oice.eq.0).or.clearsky) then
-               do ig=1, ngrid ! to stop the rad tran bug
+               do ig=1,ngrid ! to stop the rad tran bug
                   do l=1,nlayer
                      aerosol(ig,l,iaer) =1.e-9
                   end do
                end do
+
+               ! put cloud at cloudlvl
+               if(kastprof.and.(cloudlvl.ne.0.0))then
+                  ig=1
+                  do l=1,nlayer
+                     if(int(cloudlvl).eq.l)then
+                     !if(cloudlvl.gt.(pplay(ig,l)/pplev(ig,1)))then
+                        print*,'Inserting cloud at level ',l
+                        !aerosol(ig,l,iaer)=10.0
+
+                        rho_ice=920.0
+
+                        ! the Kasting approximation
+                        aerosol(ig,l,iaer) =                      &
+                          (  0.75 * QREFvis3d(ig,l,iaer) /        &
+                          ( rho_ice * reffrad(ig,l,iaer) )  ) *   &
+                          !( pq(ig,l,i_h2oice) + 1.E-9 ) *         &
+                          ( 4.0e-4 + 1.E-9 ) *         &
+                          ( pplev(ig,l) - pplev(ig,l+1) ) / g
+
+
+                        open(115,file='clouds.out',form='formatted')
+                        write(115,*) l,aerosol(ig,l,iaer)
+                        close(115)
+
+                        return
+                     endif
+                  end do
+
+                  call abort
+               endif
+
             else
                do ig=1, ngrid
@@ -232,6 +264,6 @@
 !       2. Opacity calculation
 
-            do l=1,nlayer
-               do ig=1,ngrid-1 ! to stop the rad tran bug
+            do ig=1,ngrid
+               do l=1,nlayer
                   zp=700./pplay(ig,l)
                   aerosol(ig,l,1)=(dusttau/700.)*(pplev(ig,l)-pplev(ig,l+1)) &
Index: /trunk/LMDZ.GENERIC/libf/phystd/bilinear.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/bilinear.F90	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/bilinear.F90	(revision 305)
@@ -0,0 +1,80 @@
+!-------------------------------------------------------------------------
+      subroutine bilinear(x_arr,y_arr,nX,nY,f2d_arr,x_in,y_in,f)
+!     Necessary for interpolation of continuum data
+
+      implicit none
+
+      integer nX,nY,i,j,a,b
+
+      real*8 x_in,y_in,x,y,x1,x2,y1,y2
+      real*8 f,f11,f12,f21,f22,fA,fB
+      real*8 x_arr(nX)
+      real*8 y_arr(nY)
+      real*8 f2d_arr(nX,nY)
+      
+      integer strlen
+      character*100 label
+      label='subroutine bilinear'
+
+      x=x_in
+      y=y_in
+
+!     1st check we're within the wavenumber range
+      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+         f=0.0D+0
+         return
+      else
+         
+!     in the x (wavenumber) direction 1st
+         i=1
+ 10      if (i.lt.(nX+1)) then
+            if (x_arr(i).gt.x) then
+               x1=x_arr(i-1)
+               x2=x_arr(i)
+               a=i-1
+               i=9999
+            endif
+            i=i+1
+            goto 10
+         endif
+      endif
+      
+      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+         write(*,*) 'Warning from bilinear.for:'
+         write(*,*) 'Outside continuum temperature range!'
+         if(y.lt.y_arr(1))then
+            y=y_arr(1)+0.01
+         endif
+         if(y.gt.y_arr(nY))then
+            y=y_arr(nY)-0.01
+         endif
+      else
+
+!     in the y (temperature) direction 2nd
+         j=1
+ 20      if (j.lt.(nY+1)) then
+            if (y_arr(j).gt.y) then
+               y1=y_arr(j-1)
+               y2=y_arr(j)
+               b=j-1
+               j=9999
+            endif
+            j=j+1
+            goto 20
+         endif
+      endif
+      
+      f11=f2d_arr(a,b)
+      f21=f2d_arr(a+1,b)
+      f12=f2d_arr(a,b+1)
+      f22=f2d_arr(a+1,b+1)
+      
+!     1st in x-direction
+      fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
+      fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
+      
+!     then in y-direction
+      f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
+      
+      return
+    end subroutine bilinear
Index: /trunk/LMDZ.GENERIC/libf/phystd/calc_rayleigh.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/calc_rayleigh.F90	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/calc_rayleigh.F90	(revision 305)
@@ -46,11 +46,9 @@
 
       ! tau0/p0=tau/p (Hansen 1974)
-      ! Then calculate tau0 = (8*pi^3*p_1atm)/(3*N0)  *  4*delta^2/(g*mugaz*lambda^4)
-      ! Then calculate tau0 = 1.16e-20 * 4*delta^2/(g*mugaz*lambda^4 [in um])
-      ! where delta=n-1
+      ! Then calculate tau0 = (8*pi^3*p_1atm)/(3*N0^2) * 4*delta^2/(g*mugaz*lambda^4)
+      ! where delta=n-1 and N0 is an amagat
 
       typeknown=.false.
       do igas=1,ngasmx
-         !if((igas.eq.vgas).or.(gfrac(igas).lt.1.e-4))then
          if(igas.eq.vgas)then
             print*,'Ignoring ',gnom(igas),' in Rayleigh scattering '// &
@@ -60,5 +58,5 @@
             'as its mixing ratio is less than 0.05.' 
             ! ignore variable gas in Rayleigh calculation
-            ! ignore gases of mixing ratio < 1e-4 in Rayleigh calculation
+            ! ignore gases of mixing ratio < 0.05 in Rayleigh calculation
             tauconsti(igas) = 0.0
          else
@@ -67,9 +65,11 @@
             elseif(gnom(igas).eq.'N2_')then
                tauconsti(igas) = (9.81/g)*8.569E-3*scalep/(P0/93.0)
+            elseif(gnom(igas).eq.'H2O')then
+               tauconsti(igas) = (10.0/g)*9.22E-3*scalep/101325.0 
             elseif(gnom(igas).eq.'H2_')then
-               tauconsti(igas) = (10.0/g)*0.0487*scalep/(101325.0)
+               tauconsti(igas) = (10.0/g)*0.0241*scalep/101325.0
+               !tauconsti(igas) = (10.0/g)*0.0487*scalep/(101325.0)
                ! uses n=1.000132 from Optics, Fourth Edition.
-               ! around four times more opaque than CO2
-               ! around 5.5 times more opaque than air
+               ! was out by a factor 2!
             elseif(gnom(igas).eq.'He_')then
                print*,'Helium not ready yet!'
@@ -104,8 +104,7 @@
             tauvar=0.0
             do igas=1,ngasmx
-               !if((igas.eq.vgas).or.(gfrac(igas).lt.1.e-4))then
                if((igas.eq.vgas).or.(gfrac(igas).lt.5.e-2))then
                   ! ignore variable gas in Rayleigh calculation
-                  ! ignore gases of mixing ratio < 1e-4 in Rayleigh calculation
+                  ! ignore gases of mixing ratio < 0.05 in Rayleigh calculation
                   tauvari(igas)   = 0.0
                else
@@ -114,6 +113,8 @@
                   elseif(gnom(igas).eq.'N2_')then
                      tauvari(igas) = (1.0+0.0113/wl**2+0.00013/wl**4)/wl**4
+                  elseif(gnom(igas).eq.'H2O')then
+                     tauvari(igas) = 1.0/wl**4 ! to be improved...
                   elseif(gnom(igas).eq.'H2_')then
-                     tauvari(igas) = 1.0/wl**4 ! no wvl dependence of ref. index here - improve?
+                     tauvari(igas) = 1.0/wl**4 
                   else
                      print*,'Error in calc_rayleigh: Gas species not recognised!'
@@ -138,8 +139,8 @@
       end do
 
-      print*,'At 1 atm and lambda = ',WAVEV(L_NSPECTV-5), &
-           ' um, tau_R = ',TAURAY(L_NSPECTV-5)*1013.25
-      print*,'At 1 atm and lambda = ',WAVEV(L_NSPECTV-6), &
-           ' um, tau_R = ',TAURAY(L_NSPECTV-6)*1013.25
+      print*,'At 1 atm and lambda = ',WAVEV(L_NSPECTV-6),' um'
+      print*,'tau_R = ',TAURAY(L_NSPECTV-6)*1013.25
+      print*,'sig_R = ',TAURAY(L_NSPECTV-6)*g*mugaz*1.67e-27*100, &
+             'cm^2 molecule^-1'
 
     end subroutine calc_rayleigh
Index: /trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90	(revision 305)
@@ -0,0 +1,79 @@
+subroutine calcenergy_kcm(Tsurf,T,Play,Plev,Qsurf,Q,muvar,Eatmtot)
+
+
+use params_h, only : Rc
+use watercommon_h, only : mH2O
+implicit none
+
+!     ----------------------------------------------------------------
+!     Purpose: Calculate total energy of the (steam) atmosphere
+!     Authour: R. Wordsworth (2011)
+!     ----------------------------------------------------------------
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+!#include "callkeys.h"
+
+
+
+  ! inputs
+  real Tsurf,T(1:nlayermx)
+  real Play(1:nlayermx),Plev(1:nlayermx+1)
+  real Qsurf,Q(1:nlayermx)
+  real muvar(ngridmx,nlayermx+1)
+
+  ! internal
+  integer il
+  real m_n,m_v,cp_n,cp_v,cp_a,Eatmlay
+  real s_c,rho_v,L
+  double precision p_v, s_v, nul
+  real VMR(1:nlayermx)
+
+  ! output
+  real Eatmtot
+
+  ! functions
+  double precision cp_neutral
+
+  m_n = mugaz/1000.
+  m_v = mH2O/1000.
+
+
+  do il=1,nlayermx
+     VMR(il)=Q(il)*(muvar(1,il+1)/mH2O)
+  end do
+
+
+  Eatmtot = 0.0
+  do il=1,nlayermx
+
+
+     cp_n = cp_neutral(dble(T(il)))
+     cp_v = (32.24+1.923d-3*T(il) + 1.055d-5*T(il)**2-3.511d-9*T(il)**3)/m_v
+     ! / by m_v makes it per kg not per mol
+
+     call psat_H2O(dble(T(il)),p_v)
+     p_v   = p_v*1d6
+     rho_v = real(p_v)*m_v/(real(Rc)*T(il))
+
+     call therm(dble(T(il)),dble(rho_v)*1d-3,nul,nul,nul,nul,nul,nul,nul,&
+                nul,nul,nul,s_v,nul)
+
+     s_c = 2.06 * log(T(il)/273.15)
+     s_v = s_v * 1d3
+     s_c = s_c * 1d3
+     L   = (real(s_v)-s_c)*T(il)
+
+     cp_a    = (1-VMR(il))*cp_n + VMR(il)*cp_v 
+     !cp_a    = (1-Q(il))*cp_n + Q(il)*cp_v 
+
+     Eatmlay = ( cp_a*T(il) + L*VMR(il) ) * (Plev(il)-Plev(il+1))/g
+
+     Eatmtot = Eatmtot + Eatmlay 
+  enddo
+
+  print*,'WARNING: E-calc currently assumes H2O saturation!'
+
+end subroutine calcenergy_kcm
+
Index: /trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 305)
@@ -1,9 +1,10 @@
-      subroutine callcorrk(icount,ngrid,nlayer,pq,nq,qsurf,    &
+      subroutine callcorrk(ngrid,nlayer,pq,nq,qsurf,    &
           albedo,emis,mu0,pplev,pplay,pt,                      & 
-          tsurf,fract,dist_star,aerosol,cpp3D,                 &
+          tsurf,fract,dist_star,aerosol,cpp3D,muvar,           &
           dtlw,dtsw,fluxsurf_lw,                               &
           fluxsurf_sw,fluxtop_lw,fluxabs_sw,fluxtop_dn,        &
-          reffrad,tau_col,ptime,pday,cloudfrac,totcloudfrac,   &
+          reffrad,tau_col,cloudfrac,totcloudfrac,   &
           clearsky,firstcall,lastcall)
+
 
       use radinc_h
@@ -117,5 +118,5 @@
       real*8 taugsurfi(L_NSPECTI,L_NGAUSS-1)
 
-      real*8 qvar(L_LEVELS)          ! mixing ratio of variable component
+      real*8 qvar(L_LEVELS)          ! mixing ratio of variable component (mol/mol)
       REAL pq(ngridmx,nlayer,nq)
       REAL qsurf(ngridmx,nqmx)       ! tracer on surface (e.g. kg.m-2)
@@ -159,8 +160,7 @@
       character(len=2)  :: tempOLR
       character(len=30) :: filenomOLR
-      real ptime, pday
+      !real ptime, pday
       logical OLRz
       real OLR_nu(ngrid,L_NSPECTI)
-
       real GSR_nu(ngrid,L_NSPECTV)
       real*8 NFLUXGNDV_nu(L_NSPECTV)
@@ -177,7 +177,4 @@
       real pqtest(ngridmx,nlayer,nq)
 
-!     for Dave Crisp LBL data comparison
-      logical crisp
-
 !     are particle radii fixed?
       logical radfixed
@@ -187,5 +184,9 @@
       external CBRT
 
-      crisp=.false.
+!     included by RW for runway greenhouse 1D study
+      real muvar(ngridmx,nlayermx+1)
+      real vtmp(nlayermx)
+      REAL*8 muvarrad(L_LEVELS)
+
       radfixed=.false.
 
@@ -245,4 +246,5 @@
          Cmk= 0.01 * 1.0 / (g * mugaz * 1.672621e-27) ! q_main=1.0 assumed
 
+
          if((igcm_h2o_vap.eq.0) .and. varactive)then
             print*,'varactive in callcorrk but no h2o_vap tracer.'
@@ -265,4 +267,8 @@
       enddo
 
+
+      if(kastprof)then
+         radfixed=.true.
+      endif
 
       if(radfixed)then
@@ -276,5 +282,6 @@
             do l=1,nlayer
                do ig=1,ngrid
-                  reffrad(ig,l,2) = 2.e-5 ! H2O ice
+                  !reffrad(ig,l,2) = 2.e-5 ! H2O ice
+                  reffrad(ig,l,2) = 5.e-6 ! H2O ice
                enddo
             enddo
@@ -297,8 +304,11 @@
 
          maxrad=0.0
+         !averad=0.0
          minrad=1.0
          do l=1,nlayer
+
+            !masse = (pplev(ig,l) - pplev(ig,l+1))/g
+
             do ig=1,ngrid
-
                if(tracer)then
                   reffrad(ig,l,1) = CBRT( 3*pq(ig,l,igcm_co2_ice)/ &
@@ -308,4 +318,5 @@
                reffrad(ig,l,1) = min(reffrad(ig,l,1),500.e-6)
 
+               !averad = averad + reffrad(ig,l,1)*area(ig)
                maxrad = max(reffrad(ig,l,1),maxrad)
                minrad = min(reffrad(ig,l,1),minrad)
@@ -345,4 +356,5 @@
       endif
 
+
 !     how much light we get
       fluxtoplanet=0
@@ -360,4 +372,5 @@
            reffrad,QREFvis3d,QREFir3d,                             & 
            tau_col,cloudfrac,totcloudfrac,clearsky)                ! get aerosol optical depths
+
 
 !-----------------------------------------------------------------------
@@ -512,8 +525,6 @@
       endif
 
-      if(ngridmx.eq.1) then       ! fixed zenith angle in 1D
+      if(ngridmx.eq.1) then       ! fixed zenith angle 'szangle' in 1D
          acosz = cos(pi*szangle/180.0)
-         !acosz=mu0(ig)
-         !print*,'oned SZ angle OVERRIDE in callcorrk'
          print*,'acosz=',acosz,', szangle=',szangle
       else
@@ -521,17 +532,15 @@
       endif
 
-!-----------------------------------------------------------------------
-!     Water vapour (to be generalised / ignored for other planets)
+
+!-----------------------------------------------------------------------
+!     Water vapour (to be generalised for other gases eventually)
       
-      if(varactive) then
+      if(varactive)then
 
          i_var=igcm_h2o_vap
-
          do l=1,nlayer
-
             qvar(2*l)   = pq(ig,nlayer+1-l,i_var)
             qvar(2*l+1) = (pq(ig,nlayer+1-l,i_var)+pq(ig,max(nlayer-l,1),i_var))/2    
             ! Average approximation as for temperature...
-
          end do
          qvar(1)=qvar(2)
@@ -575,8 +584,39 @@
       end if
 
-      ! Now convert from kg/kg to mol/mol
+      ! IMPORTANT: Now convert from kg/kg to mol/mol
       do k=1,L_LEVELS
          qvar(k) = qvar(k)/epsi
       end do
+
+      if(kastprof)then
+
+         DO l=1,nlayer
+            muvarrad(2*l)   = muvar(ig,nlayer+2-l)
+            muvarrad(2*l+1) = (muvar(ig,nlayer+2-l) + &
+                                muvar(ig,max(nlayer+1-l,1)))/2
+         END DO
+      
+         muvarrad(1) = muvarrad(2)
+         muvarrad(2*nlayermx+1)=muvar(ig,1)
+
+         print*,'Recalculating qvar with VARIABLE epsi for kastprof'
+         i_var=igcm_h2o_vap
+         do l=1,nlayer
+            vtmp(l)=pq(ig,l,i_var)*muvar(ig,l+1)/mH2O
+         end do
+
+         do l=1,nlayer
+            qvar(2*l)   = vtmp(nlayer+1-l)
+            qvar(2*l+1) = ( vtmp(nlayer+1-l) + vtmp(max(nlayer-l,1)) )/2
+         end do
+         qvar(1)=qvar(2)
+         qvar(2*nlayermx+1)=qsurf(ig,i_var)*muvar(ig,1)/mH2O
+
+         !do k=1,L_LEVELS
+         !   qvar(k) = 1.0
+         !end do
+         !print*,'ASSUMING qH2O=1 EVERYWHERE IN CALLCORRK!!'
+
+      endif
 
       ! Keep values inside limits for which we have radiative transfer coefficients
@@ -607,17 +647,4 @@
       tlevrad(2*nlayermx+1)=tsurf(ig)
       
-
-      if(crisp)then
-         open(111,file='/u/rwlmd/CrispLBL/p.dat')
-         open(112,file='/u/rwlmd/CrispLBL/T.dat')
-         do k=1,L_LEVELS
-            read(111,*) plevrad(k)
-            read(112,*) tlevrad(k)
-            plevrad(k)=plevrad(k)*1000.0
-         enddo
-         close(111)
-         close(112)
-      endif
-
       tmid(1) = tlevrad(2)
       tmid(2) = tlevrad(2)
@@ -651,11 +678,12 @@
             print*,'Minimum temperature is outside the radiative'
             print*,'transfer kmatrix bounds, exiting.'
-            !print*,'WARNING, OVERRIDING FOR TEST'
-            call abort
+            print*,'WARNING, OVERRIDING FOR TEST'
+            !call abort
          elseif(tlevrad(k).gt.tgasmax)then
             print*,'Maximum temperature is outside the radiative'
             print*,'transfer kmatrix bounds, exiting.'
-            !print*,'WARNING, OVERRIDING FOR TEST'
-            call abort
+            print*,'WARNING, OVERRIDING FOR TEST'
+            !print*, 'T=',pt
+            !call abort
          endif
       enddo
@@ -688,5 +716,5 @@
             call optcv(dtauv,tauv,taucumv,plevrad,                 &
                  qxvaer,qsvaer,gvaer,wbarv,cosbv,tauray,tauaero,   &
-                 tmid,pmid,taugsurf,qvar)
+                 tmid,pmid,taugsurf,qvar,muvarrad)
 
 
@@ -704,5 +732,5 @@
          end if
 
-	!print*,'taugsurf=',taugsurf(:,L_NGAUSS-1)
+
 
 
@@ -712,5 +740,5 @@
          call optci(plevrad,tlevrad,dtaui,taucumi,                  &
               qxiaer,qsiaer,giaer,cosbi,wbari,tauaero,tmid,pmid,    &
-              taugsurfi,qvar)
+              taugsurfi,qvar,muvarrad)
 
          call sfluxi(plevrad,tlevrad,dtaui,taucumi,ubari,albi,      &
@@ -729,4 +757,5 @@
          fluxsurf_lw(ig) = real(fluxdni(L_NLAYRAD))
          fluxsurf_sw(ig) = real(fluxdnv(L_NLAYRAD))
+
 
          if(fluxtop_dn(ig).lt.0.0)then
@@ -740,18 +769,4 @@
          endif
 
-         if(crisp)then
-            open(111,file='/u/rwlmd/CrispLBL/GCMfluxdn.dat')
-            open(112,file='/u/rwlmd/CrispLBL/GCMfluxup.dat')
-            do k=1,L_NLAYRAD
-               write(111,*) fluxdni(k)
-               write(112,*) fluxupi(k)
-            enddo
-            close(111)
-            close(112)
-            print*,'fluxdni',fluxdni
-            print*,'fluxupi',fluxupi
-            call abort
-         endif
-
 !     Spectral output, for exoplanet observational comparison
          if(specOLR)then
@@ -809,21 +824,13 @@
       if(specOLR)then
         if(ngrid.ne.1)then
-          call writediagspec(ngrid,"OLR3D","OLR(lon,lat,band)","W m^-2",3,OLR_nu)
-!          call writediagspec(ngrid,"OSR3D","OSR(lon,lat,band)","W m^-2",3,OSR_nu)
+          call writediagspecIR(ngrid,"OLR3D","OLR(lon,lat,band)","W m^-2",3,OLR_nu)
+          call writediagspecVI(ngrid,"GSR3D","GSR(lon,lat,band)","W m^-2",3,GSR_nu)
         endif
       endif
 
-      if(ngrid.eq.1)then
-         open(113,file='surf_vals_long.out',ACCESS='append')
-         write(113,*) tsurf(1),fluxtop_dn(1),         &
-              real(-nfluxtopv),real(nfluxtopi) 
-         close(113)
-      endif
-
-      !if(kastprof)then ! for kasthop only
-
-        if(ngrid.eq.1)then
-
-           print*,'Saving tsurf,psurf in surf_vals.out...'
+      if(lastcall.and.(ngrid.eq.1))then
+
+           print*,'Saving scalar quantities in surf_vals.out...'
+           print*,'psurf = ', pplev(1,1),' Pa'
            open(116,file='surf_vals.out')
            write(116,*) tsurf(1),pplev(1,1),fluxtop_dn(1),         &
@@ -843,22 +850,4 @@
                enddo
                close(127)
-           endif
-
-!     mixing ratio: CO2 ice particles
-           if(igcm_co2_ice.ne.0)then
-              open(122,file='qCO2ice.out')
-              do l=1,L_NLAYRAD
-                 write(122,*) pq(1,l,igcm_co2_ice)
-              enddo
-              close(122)
-           endif
-
-!     mixing ratio: H2O vapour
-           if(igcm_h2o_vap.ne.0)then
-              open(123,file='qH2Ovap.out')
-              do l=1,L_NLAYRAD
-                 write(123,*) pq(1,l,igcm_h2o_vap)
-              enddo
-              close(123)
            endif
 
@@ -878,7 +867,6 @@
               close(119)
            endif
-        endif
-
-      !endif
+
+      endif
 
     end subroutine callcorrk
Index: /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 305)
@@ -16,5 +16,5 @@
      &   , kastprof                                                     &
      &   , noradsurf                                                    &
-     &   , Tsurfk                                                       &
+     &   , graybody                                                     &
      &   , Tstrat                                                       &
      &   , newtonian                                                    &
@@ -45,4 +45,5 @@
      &   , n2mixratio                                                   &
      &   , co2supsat                                                    &
+     &   , cloudlvl                                                     &
      &   , pceil                                                    
 
@@ -73,4 +74,5 @@
       logical CLFvarying
       logical noradsurf
+      logical graybody
 
       integer iddist
@@ -97,4 +99,4 @@
       real maxicethick
       real Tsaldiff
-      real Tsurfk
       real tau_relax
+      real cloudlvl
